# HVL bachelor project 22 - a tool for centralized logging

### Install guide
[Docker](https://docs.docker.com/install) and [Docker Compose](https://docs.docker.com/compose/install) are required to be installed in order for this tool to run. 

FIRST TIME STUP:

Step 1: Open up the terminal of your choice, navigate to the folder where you cloned the repository and first write "sudo docker volume create grafana-storage". This is to create the volume needed to store the Grafana configuration so everything doesn't reset in case the server or Docker shuts down.

Step 2: Write "docker compose up". Press enter to run. Docker Compose should then automatically get everything ready for you.

Step 3:  Go to [http://158.39.77.99:3000/](http://158.39.77.99:3000/) and login with the default admin account. Username and password are both "admin".

Step 4: Navigate to Data Sources under Configuration on the left side of the screen and press "Add Data Source".

Step 5: Choose Loki. In the URL field under HTTP write "http://loki:3100" and press "Save & test". The "loki" part of the URL is whatever you have defined the network name in the Docker Compose's YAML configuration file.

Step 6: Navigate to Explore on the left side of the screen. In the log browser field, write the following query {job="varlogs"}. The job name can be changed in Promtail's configuration.

Step 7: Press "Run query" on the upper right part of the screen and the log messages will show up.


OPTIONAL SWITCH TO LOCAL DB:

Step 1: In the Docker Compose configuration file, remove "-target=all,table-manager" under Services -> Loki -> command. 

Step 2: Change "./loki:/etc/loki" under Services -> Loki -> volumes to "./loki-localDB:/etc/loki". This switches over to an alternate Loki config file in which local storage is used.
